<template lang="pug">
q-input.rounded-borders.ui-input-text(
	v-bind="$props",
	v-model="model",
	hide-bottom-space
	dense
	:lazy-rules="true"
	outlined
	:required="undefined"
	:label="label"
	:rules="getRules"
)
	template(#prepend="props")
		slot(name="prepend" :props="props")
	template(#append="props")
		slot(name="append" :props="props")
</template>

<script lang="ts" setup>
	import { defineProps, computed, defineEmits } from 'vue'
	const props = defineProps({
		modelValue: [String, Number],
		type: {
			type: String,
			default: 'text',
		},
		label: {
			type: String,
			default: '',
		},
		required: {
			type: Boolean,
			default: false,
		},
		rules: {
			type: Array,
			default: () => [],
		},
	})
	const getRules = computed(() => {
		const hasValue = props.required
			? [(val: string) => val !== '' || `Необходимо указать ${props.label.toLowerCase()}`]
			: []
		const moreThenZero =
			props.required && props.type === 'number'
				? [(val: number) => val > 0 || `Значение ${props.label.toLowerCase()} должно быть больше нуля`]
				: []
		return props.rules.length || props.required ? [...hasValue, ...moreThenZero, ...props.rules] : undefined
	})
	const emit = defineEmits(['update:modelValue'])
	const model = computed({
		get() {
			return props.modelValue
		},
		set(value) {
			emit('update:modelValue', value)
		},
	})
</script>

<style lang="scss" scoped>
	.ui-input-text {
		&.q-field--focused,
		&.q-field--float {
			&:deep(.q-field__label) {
				transform: translateY(-85%) scale(0.75) !important;
				z-index: 1;
				background: $main-background;
				padding: 0 5px;
				margin-left: -5px;
				right: auto;
				max-width: calc(135% + 10px);
			}
		}

		&.q-textarea {
			&:deep(.q-field__control-container) {
				padding: 9px 0 7px !important;
			}
		}
	}
</style>
